Attribute VB_Name = "CSGLOBAL"
Option Explicit
Declare Function GetWindowsDirectory Lib "kernel32" Alias "GetWindowsDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long

'number of cards in the deck
Global Const MAXCARDS = 52

'MAXHOLD is the maximum cards computer can hold in memory
Global Const MAXHOLD = 15

'an empty card slot in the deck
Global Const NOCARD = -1

'card Delay
Global Const CARDDELAY = 2#

'player structure
Type PLAYERINFO
  Pot As Integer
  Bet As Integer
  LastBet As Integer
  CardNum As Integer
  CardSum As Integer
  Card(5) As Integer
End Type

'card structure, info where card is on form and
'what value card has
Type CARDINFO
  FormIndex As Integer  'hold location on form index
  CardIndex As Integer  'hold location of card
  CardVal As Integer    'hold card value
  CardFlag As Integer   'true id matched
End Type

'memory structure
Type MEMORYINFO
  FormIndex As Integer  'hold location on form index
  CardVal As Integer    'hold card value
  CardFlag As Integer   'true id matched
End Type

'form structure, used to hold index where card is located
Type FORMINFO
  Findex As Integer
End Type

'player values
Global Const COMPUTER = 0
Global Const PLAYER = 1

'card Information
Global CardNum%
Global CardDeck%(MAXCARDS)

'player Information
Global PInfo(2) As PLAYERINFO

'card Information, where card is on form and what
'card is in what slot
Global CInfo(52) As CARDINFO

'memory Information
'computer can hold up to 15 cards in memory
Global MemInfo(MAXHOLD) As MEMORYINFO

'form Information
Global FInfo(2) As FORMINFO

'current player
Global CurrentPlayer%
'counter for number of cards for computer to choose
Global Gnum As Integer
'set to true if to play computer
Global gExpired As Integer  'flag when over 30 days
Global PlayComputer As Integer
'set to true if to practice
Global Practice As Integer
Global Beginner As Integer
Global Intermediate As Integer
Global Advanced As Integer
Global MustReDeal As Integer    'when to redeal cards
Global InPlay As Integer        'when games is started
Global MAXARRAY As Integer
Global FCard As Integer     'first card selected for user
Global NCard As Integer     'number of new card to use
Global MyPath               'current path c:\windows
Global MyFile               'set to cs.ini file
Global NewCards             'true to refresh new backs

Global Style As String
Global Title As String
Global Help As String
Global Msg As String
Global Ans As String
Global Default As String

'messageBox
Global Const CSMSG = "Card Search"    ' used in title of msgbox
Global Const MB_OK = 0, MB_OKCANCEL = 1     ' define buttons
Global Const MB_YESNOCANCEL = 3, MB_YESNO = 4
Global Const MB_ICONSTOP = 16, MB_ICONQUESTION = 32    ' define icons
Global Const MB_ICONEXCLAMATION = 48, MB_ICONINFORMATION = 64
Global Const MB_DEFBUTTON2 = 256, IDYES = 6, IDNO = 7, IDCANCEL = 2, IDOK = 1   ' define other
Global Const MB_DEFBUTTON1 = 0, MB_DEFBUTTON3 = 512
Sub Delay(secs!)
'this procedure delays the given number of seconds, which can be fractional.

    Dim Start!

    'get the current seconds since midnight
    Start! = Timer

    'wait for seconds to elapse
    While (Timer < (Start! + secs!))
        'let other things run while we wait
        DoEvents
    Wend

End Sub
Public Function FileExists(filename As String) As Integer
    Dim X As Integer
    
    X = FreeFile
    On Error Resume Next
    Open filename For Input As X
    If Err = 0 Then
        FileExists = True
        Close X
    Else
        FileExists = False
    End If
End Function
Function GetRandom%(range%)
    'this function returns a random number between 0 and range%-1, inclusive.

    'the generic formula is:
    'Int((upperbound-lowerbound+1)*Rnd+lowerbound)
    GetRandom% = Int(range% * Rnd)

End Function
Sub ShuffleDeck()
    'this procedure "shuffles" the cards by randomizing an array of card numbers.

    Dim i%, j%, r%
    Dim Num%

    'initialize the card array to no entries
    For i% = 1 To MAXCARDS
        CardDeck%(i%) = NOCARD
    Next i%

    'randomize the cards
    For i% = 1 To MAXCARDS
        'get a random number, between cards left
        r% = GetRandom%(MAXCARDS - i%) + 1
        'now search for that slot
        j% = 1
        While (r% > 0)
            'position filled?
            If (CardDeck%(j%) = NOCARD) Then
                'no, so count it
                r% = r% - 1
            End If
            'bump to next card slot
            If (r% > 0) Then
                j% = j% + 1
            End If
        Wend
        'store card in this slot
        CardDeck(j%) = i%
    Next i%

    'need to remove king of hearts from being stored in
    'last slot, get new slot and switch cards in array
    r% = GetRandom%(MAXCARDS - 1) + 1
    Num% = CardDeck(r%)
    CardDeck(r%) = 52
    CardDeck(52) = Num%

    'deal from the first card
    CardNum% = 1

End Sub
